package com.lzmispt.data.resource.service.metadata.impl;

package .tmp;

import com.lzmispt.data.center.entity.dto.databasestruct.DBColumnDTO;
import com.lzmispt.data.center.entity.dto.databasestruct.DataSourceDTO;
import com.lzmispt.data.center.entity.dto.resource.apply.GetApplyEntityInfoVO;
import com.lzmispt.data.center.entity.dto.resource.apply.GetDataTableConnectionInfoVO;
import com.lzmispt.data.center.entity.dto.resource.apply.GetFileTableInfoVO;
import com.lzmispt.data.center.entity.dto.resource.metadata.DataBrowseQueryDTO;
import com.lzmispt.data.center.entity.dto.resource.metadata.FileDataQueryDTO;
import com.lzmispt.data.center.entity.enums.StatusCodeEnum;
import com.lzmispt.data.center.entity.vo.standard.metadata.MetadataEntityDataItemVO;
import com.lzmispt.data.resource.client.DataApplyClient;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataEntityDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataFileFieldDTO;
import com.lzmispt.data.resource.entity.dto.resanddata.ResAndDataFileTableDTO;
import com.lzmispt.data.resource.entity.po.metadata.MetadataEntityInfoItemPO;
import com.lzmispt.data.resource.service.metadata.impl.DataBrowseManager;
import com.lzmispt.dcbase.databasestruct.DataStructProvider;
import com.lzmispt.dcbase.dcconst.DCConst;
import com.lzmispt.framework.entity.entity.ResultEntity;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.function.Function;
import java.util.stream.Collectors;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

@Service
public class ApplyDataBrowseImpl extends DataBrowseManager {
  @Resource
  DataApplyClient dataApplyClient;
  
  public Object selectInfo(int directoryId) {
    return null;
  }
  
  public String getDefaultCode() {
    return "Apply";
  }
  
  public ResultEntity<Map<String, Object>> getDataBrowseByDirectoryId(DataBrowseQueryDTO dataBrowseQueryDTO, boolean withAsCnName, String tokenId, String platCode, Boolean selectAll) {
    Long directoryId = dataBrowseQueryDTO.getDirectoryId();
    List<MetadataEntityInfoItemPO> infoItems = new ArrayList<>();
    List<MetadataEntityDataItemVO> dataItems = new ArrayList<>();
    ResAndDataEntityDTO entity = getEntityAndInfoItemsByEntityId(infoItems, dataItems, directoryId, tokenId);
    if (entity == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DIRECTORY_DATA_RESOURCE_NO_EXISTS.getCode()), StatusCodeEnum.DATA_RESOURCE_DIRECTORY_DATA_RESOURCE_NO_EXISTS
          .getMessage(), null); 
    if (CollectionUtils.isEmpty(infoItems)) {
      if ("Collection".equals(getDefaultCode()))
        return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DATA_ENTITY_INVALID_COLLECTION.getCode()), StatusCodeEnum.DATA_RESOURCE_DATA_ENTITY_INVALID_COLLECTION
            .getMessage(), null); 
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_DATA_ENTITY_INVALID_MANAGE.getCode()), StatusCodeEnum.DATA_RESOURCE_DATA_ENTITY_INVALID_MANAGE
          .getMessage(), null);
    } 
    Map<Long, MetadataEntityDataItemVO> dataItemMap = (Map<Long, MetadataEntityDataItemVO>)dataItems.stream().filter(Objects::nonNull).collect(Collectors.toMap(MetadataEntityDataItemVO::getDataItemId, Function.identity(), (k1, k2) -> k2));
    DataSourceDTO dataSourceDTO = getDataSourceDTO(directoryId, Boolean.valueOf(false), tokenId);
    if (dataSourceDTO == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_CONFIG_DB_NO_DATA.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_CONFIG_DB_NO_DATA
          .getMessage(), null); 
    ResultEntity<DataStructProvider> getDataBaseProviderRet = DataStructProvider.getDataBaseProvider(dataSourceDTO, true, false);
    if (!getDataBaseProviderRet.getCode().equals(Integer.valueOf(0)))
      return ResultEntity.errorMessage(getDataBaseProviderRet.getCode(), getDataBaseProviderRet.getMsg()); 
    DataStructProvider dataStructProvider = (DataStructProvider)getDataBaseProviderRet.getObj();
    return executeDataBrowseQuery(dataBrowseQueryDTO, entity, dataSourceDTO, infoItems, dataItemMap, withAsCnName, Integer.valueOf(1), dataStructProvider, tokenId, null, Integer.valueOf(0), "Apply", selectAll, null);
  }
  
  public ResultEntity<Map<String, Object>> getFileDataListByPrimaryKey(FileDataQueryDTO fileDataQueryDTO, String tokenId, String platCode) {
    Long directoryId = fileDataQueryDTO.getDirectoryId();
    Map<String, Object> resultMap = new HashMap<>();
    List<ResAndDataFileFieldDTO> fileInfoFieldList = new ArrayList<>();
    ResAndDataFileTableDTO fileInfoTable = getFileTableAndFieldByEntityId(fileInfoFieldList, directoryId, tokenId);
    if (fileDataQueryDTO.getListSource() != null)
      if (DCConst.FALSE.equals(fileDataQueryDTO.getListSource())) {
        fileInfoFieldList = (List<ResAndDataFileFieldDTO>)fileInfoFieldList.stream().filter(f -> !DCConst.FALSE.equals(f.getShowInBrowse())).collect(Collectors.toList());
      } else if (DCConst.TRUE.equals(fileDataQueryDTO.getListSource())) {
        fileInfoFieldList = (List<ResAndDataFileFieldDTO>)fileInfoFieldList.stream().filter(f -> !DCConst.FALSE.equals(f.getShowInEdit())).collect(Collectors.toList());
      }  
    if (fileInfoTable == null) {
      resultMap.put("dataList", new ArrayList());
      resultMap.put("total", Integer.valueOf(0));
      return ResultEntity.successMessage(resultMap);
    } 
    DataSourceDTO dataSourceDTO = getDataSourceDTO(fileInfoTable.getFileTableId(), Boolean.valueOf(true), tokenId);
    if (dataSourceDTO == null)
      return ResultEntity.errorMessage(Integer.valueOf(StatusCodeEnum.DATA_RESOURCE_NO_CONFIG_DB_NO_DATA.getCode()), StatusCodeEnum.DATA_RESOURCE_NO_CONFIG_DB_NO_DATA
          .getMessage(), null); 
    ResultEntity<DataStructProvider> getDataBaseProviderRet = DataStructProvider.getDataBaseProvider(dataSourceDTO, true, false);
    if (!getDataBaseProviderRet.getCode().equals(Integer.valueOf(0)))
      return ResultEntity.errorMessage(getDataBaseProviderRet.getCode(), getDataBaseProviderRet.getMsg()); 
    DataStructProvider dataStructProvider = (DataStructProvider)getDataBaseProviderRet.getObj();
    return executeQueryFileData(fileDataQueryDTO, fileInfoTable, fileInfoFieldList, dataSourceDTO, dataStructProvider, tokenId, Integer.valueOf(0), "Apply");
  }
  
  public ResAndDataFileTableDTO getFileTableAndFieldByEntityId(List<ResAndDataFileFieldDTO> fieldList, Long entityId, String tokenId) {
    GetFileTableInfoVO fileTableInfo = (GetFileTableInfoVO)this.dataApplyClient.getFileTableInfoByEntityId(entityId, tokenId).getObj();
    if (fileTableInfo == null)
      return null; 
    if (!CollectionUtils.isEmpty(fileTableInfo.getFieldList()))
      for (GetFileTableInfoVO.FieldInfo fieldInfo : fileTableInfo.getFieldList()) {
        ResAndDataFileFieldDTO fileInfoField = parseFileFieldInfo(fieldInfo);
        fieldList.add(fileInfoField);
      }  
    return parseFileInfoTable(fileTableInfo.getFileTableInfo());
  }
  
  public ResAndDataEntityDTO getEntityAndInfoItemsByEntityId(List<MetadataEntityInfoItemPO> infoItemList, List<MetadataEntityDataItemVO> dataItemList, Long entityId, String tokenId) {
    GetApplyEntityInfoVO applyEntityInfo = (GetApplyEntityInfoVO)this.dataApplyClient.getEntityInfoByEntityId(entityId, tokenId).getObj();
    if (applyEntityInfo == null)
      return null; 
    if (!CollectionUtils.isEmpty(applyEntityInfo.getFieldList()))
      for (GetApplyEntityInfoVO.FieldListInfo item : applyEntityInfo.getFieldList()) {
        MetadataEntityInfoItemPO metadataEntityItemInfo = parseEntityFieldInfo(item);
        MetadataEntityDataItemVO dataItemInfo = parseEntityFieldInfoToDataItem(item);
        infoItemList.add(metadataEntityItemInfo);
        dataItemList.add(dataItemInfo);
      }  
    return parseMetadataEntity(applyEntityInfo.getEntityInfo());
  }
  
  public DataSourceDTO getDataSourceDTO(Long entityId, Boolean isFileTable, String tokenId) {
    GetDataTableConnectionInfoVO connectionInfoVO;
    if (isFileTable.booleanValue()) {
      connectionInfoVO = (GetDataTableConnectionInfoVO)this.dataApplyClient.getFileTableConnectionInfo(entityId, tokenId).getObj();
    } else {
      connectionInfoVO = (GetDataTableConnectionInfoVO)this.dataApplyClient.getDataTableConnectionInfo(entityId, tokenId).getObj();
    } 
    if (connectionInfoVO == null)
      return null; 
    GetDataTableConnectionInfoVO.DataSourceInfo dataSourceInfo = connectionInfoVO.getDataSourceInfo();
    DataSourceDTO dataSourceVO = new DataSourceDTO();
    dataSourceVO.setType(dataSourceInfo.getDbType());
    dataSourceVO.setUser(dataSourceInfo.getUsername());
    dataSourceVO.setDbSchema(dataSourceInfo.getDbSchema());
    dataSourceVO.setDbName(connectionInfoVO.getDbName());
    dataSourceVO.setPort(dataSourceInfo.getPort());
    dataSourceVO.setIpName(dataSourceInfo.getDataSourceUrl());
    dataSourceVO.setPassword(dataSourceInfo.getPassword());
    return dataSourceVO;
  }
  
  public ResAndDataFileTableDTO parseFileInfoTable(GetFileTableInfoVO.FileTableInfo fileTableInfo) {
    if (fileTableInfo == null)
      return null; 
    ResAndDataFileTableDTO result = new ResAndDataFileTableDTO();
    result.setFileTableId((fileTableInfo.getFileTableId() == null) ? null : Long.valueOf(fileTableInfo.getFileTableId()));
    result.setDataSourceId((fileTableInfo.getDataSourceId() == null) ? null : Long.valueOf(fileTableInfo.getDataSourceId()));
    result.setFileTableCnName(fileTableInfo.getFileTableCnName());
    result.setFileTableName(fileTableInfo.getFileTableName());
    result.setFileRootPath(fileTableInfo.getFileRootPath());
    return result;
  }
  
  public ResAndDataEntityDTO parseMetadataEntity(GetApplyEntityInfoVO.EntityInfo entityInfo) {
    if (entityInfo == null)
      return null; 
    ResAndDataEntityDTO result = new ResAndDataEntityDTO();
    Long entityId = (entityInfo.getEntityId() == null) ? null : Long.valueOf(entityInfo.getEntityId());
    result.setDirectoryId(entityId);
    result.setEntityId(entityId);
    result.setDataSourceId((entityInfo.getDataSourceId() == null) ? null : Long.valueOf(entityInfo.getDataSourceId()));
    result.setEntityTableName(entityInfo.getEntityTableName());
    result.setEntityName(entityInfo.getEntityName());
    return result;
  }
  
  private ResAndDataFileFieldDTO parseFileFieldInfo(GetFileTableInfoVO.FieldInfo item) {
    if (item == null)
      return null; 
    ResAndDataFileFieldDTO result = new ResAndDataFileFieldDTO();
    result.setFileTableId((item.getFileTableId() == null) ? null : Long.valueOf(item.getFileTableId()));
    result.setFieldId((item.getFieldId() == null) ? null : Long.valueOf(item.getFieldId()));
    result.setFieldLength(item.getFieldLength());
    result.setFieldCnName(item.getFieldCnName());
    result.setFieldName(item.getFieldName());
    result.setFieldOrder(item.getFieldOrder());
    result.setFieldScale(item.getFieldScale());
    result.setFieldType(item.getFieldType());
    result.setIsRequired(item.getIsRequired());
    result.setIsSystem(item.getIsSystem());
    result.setIsPrimaryKey(item.getIsPrimaryKey());
    return result;
  }
  
  public MetadataEntityDataItemVO parseEntityFieldInfoToDataItem(GetApplyEntityInfoVO.FieldListInfo field) {
    if (field == null)
      return null; 
    MetadataEntityDataItemVO result = new MetadataEntityDataItemVO();
    result.setDataItemName(field.getDataItemName());
    result.setDataItemCnName(field.getDataItemCNName());
    result.setCodeTableName(field.getCodeTableName());
    result.setDataRange(field.getDataRange());
    result.setDataLength(field.getDataLength());
    result.setDataScale(field.getDataScale());
    result.setDataType(field.getDataType());
    result.setDataItemId(Long.valueOf(field.getInfoItemId()));
    return result;
  }
  
  private MetadataEntityInfoItemPO parseEntityFieldInfo(GetApplyEntityInfoVO.FieldListInfo field) {
    if (field == null)
      return null; 
    MetadataEntityInfoItemPO result = new MetadataEntityInfoItemPO();
    result.setDataItemName(field.getDataItemName());
    result.setIsPrimaryKey(field.getIsPrimaryKey());
    result.setInfoItemName(field.getInfoItemName());
    result.setInfoItemId((field.getInfoItemId() == null) ? null : Long.valueOf(field.getInfoItemId()));
    result.setDataItemId((field.getInfoItemId() == null) ? null : Long.valueOf(field.getInfoItemId()));
    result.setInfoItemParentId(null);
    result.setInfoItemType(field.getInfoItemType());
    result.setIsRequired(field.getIsRequired());
    result.setInfoItemOrder(field.getInEntityOrder());
    result.setInfoItemStatus(field.getInfoItemStatus());
    result.setDataRange(field.getDataRange());
    result.setDataRule(field.getDataRule());
    result.setDataRuleDescription(field.getDataRuleDescription());
    return result;
  }
  
  protected boolean checkMetadataEntityInfoItemIsValid(MetadataEntityInfoItemPO metadataEntityInfoItemPO, List<DBColumnDTO> tableStructDt, MetadataEntityDataItemVO metadataEntityDataItemVO, String tokenId) {
    return true;
  }
}
